<template lang="pug">
div
  .bg-grey-4.text-center.q-pa-md(v-if='scheduled')
    .text-h5.text-grey-6 Session Scheduled
    q-btn(flat, dense, @click='scheduled = false') Schedule Another

  q-form(@submit='onSubmit', v-if='!scheduled')
    .row
      .col-12
        .row.q-col-gutter-md
          .col-6
            q-select(
              filled,
              v-model='nextSession',
              :options='templates',
              label='Select session',
              option-label='name',
              :loading='loading',
              :rules='[val => !!val || "Please choose a session"]'
            )
              template(v-slot:before)
                q-icon(name='library_books', color='primary')

          .col-6
            q-select(
              filled,
              v-model='reminder',
              emit-value,
              map-options,
              :options='reminderOptions',
              label='Send email reminder'
            )
              template(v-slot:before)
                q-icon(name='notifications', color='primary')

        .row.q-col-gutter-md
          .col-6
            q-input(filled, v-model='date', mask='date', :rules='["date"]', label='Select a date')
              template(v-slot:before)
                q-icon(name='event', color='primary')
              template(v-slot:append)
                q-icon.cursor-pointer(name='event')
                  q-popup-proxy(ref='qDateProxy', cover, transition-show='scale', transition-hide='scale')
                    q-date(v-model='date', emit-immediately, minimal, @input='$refs.qDateProxy.hide()')
                      //- .row.items-center.justify-end
                      //-   q-btn(rounded, v-close-popup, label='Close', color='primary', flat)

          .col-6
            q-input(filled, v-model='time', mask='time', :rules='["time"]', label='Select a time')
              template(v-slot:before)
                q-icon(name='access_time', color='primary')
              template(v-slot:append)
                q-icon.cursor-pointer(name='access_time')
                  q-popup-proxy(ref='qTimeProxy', cover, transition-show='scale', transition-hide='scale')
                    q-time(v-model='time', emit-immediately, minimal, @input='$refs.qTimeProxy.hide()', format24h)
                      .row.items-center.justify-end
                        q-btn(rounded, v-close-popup, label='Close', color='primary', flat)

      //- .col-12.col-lg-4
      //-   .row.q-col-gutter-md
      //-     .col(:class='{ "q-ml-md": $q.screen.lg }')
      //-       q-editor(v-model='notes', label='Add notes', style='height: 132px')

    .column.items-end
      q-btn(:class='{ "q-mt-md": $q.screen.lt.lg }', rounded, color='primary', label='Schedule Session', type='submit')
</template>

<script>
import { Loading } from 'quasar';

export default {
  name: 'Dashboard',
  props: {
    firebase: {
      required: true,
    },
    functions: {
      required: true,
    },
    context: {
      required: false,
    },
  },
  components: {},
  data: () => {
    return {
      loading: true,
      nextSession: null,
      reminder: '0',
      date: null,
      time: null,
      // notes: '',
      templates: null,
      reminders: null,
      scheduled: false,
    };
  },
  computed: {
    reminderOptions() {
      let res = [];
      for (const k in this.reminders) {
        res.push({
          value: k,
          label: this.reminders[k],
        });
      }
      return res;
    },
  },
  methods: {
    getStartTime() {
      const offset = new Date().getTimezoneOffset() / 60;
      return `${this.date.replaceAll('/', '-')}T${this.time}:00.000${offset > 0 ? '-' : '+'}${Math.abs(offset)}:00`;
    },
    async onSubmit() {
      try {
        if (!this.nextSession || !this.date || !this.time || !this.reminder) return false;
        else {
          const startDate = new Date(this.getStartTime());
          const startTime = startDate.toISOString();
          const endDate = new Date(this.getStartTime());
          endDate.setHours(endDate.getHours() + 1);
          const endTime = endDate.toISOString();

          // Get coach uid & patient uid from `meetingMeta` data node
          // let coachUid;
          // let patientUid;

          // //if its in a meeting:
          // if (this.context.meetingid) {
          //   const meta = (await this.firebase.ref(`data/meetingMeta/${this.context.meetingid}`).once('value')).val();
          //   coachUid = meta.uid;
          //   patientUid = meta.patientUid;
          // } else {
          //   coachUid = this.context.coachUid;
          //   patientUid = this.context.patientUid;
          // }

          // Call the scheduleNextSession callable function for creating a new calendar event
          const scheduleNextSession = this.functions.httpsCallable('Schedule-scheduleNextSession');
          const nextSessionObj = {
            startTime,
            endTime,
            coachUid: this.context.meetingid,
            patientUid: this.context.sequenceid,
            template: this.nextSession.id,
            topic: this.nextSession.name,
            type: 'Vonage',
            reminder: this.reminder,
          };

          Loading.show({
            message:
              'Session creation is in progress.<br/><span class="text-orange text-weight-bold">Hang on...</span>',
          });
          await scheduleNextSession(nextSessionObj);
          Loading.hide();
          this.scheduled = true;
        }
      } catch (error) {
        console.error('error: ', error);
        this.$q.notify({
          type: 'negative',
          message: error,
        });
        Loading.hide();
      }
    },
  },
  watch: {
    firebase: {
      immediate: true,
      async handler() {
        // this.$rtdbBind('sessions', this.firebase.ref('meta/session'));
        this.$rtdbBind('reminders', this.firebase.ref('meta/reminder'));

        try {
          // this.nextSession = { id: 'TEST', name: 'TEST' };

          // this.templates = await this.functions.httpsCallable('templates-listTemplates')({});
          this.templates = Object.values((await this.functions.httpsCallable('templates-listTemplates')({})).data);

          this.loading = false;
        } catch (e) {
          console.error(e);
        }
        // console.log(this.sessions);
      },
    },
  },
};
</script>

<style lang="scss" scoped></style>
